# -- coding: utf-8 -- 
import datetime
import os
from pygame import mixer

'''
Thanks to PhD Candidate Eivind Seim at the Faculty of Science and Technology at the Norwegian University of Life Sciences (NMBU) in spurring the start of this script. 
'''

''' 
getChar function written by Matthew Strax-Haber found on Stack Overflow [November 11, 2017].
https://stackoverflow.com/questions/510357/python-read-a-single-character-from-the-user
'''
# This function lets Python read a single character from the user without having to press return afterwards. 
def getChar():
    # figure out which function to use once, and store it in _func
    if "_func" not in getChar.__dict__:
        try:
            # for Windows-based systems
            import msvcrt # If successful, we are on Windows
            getChar._func=msvcrt.getch

        except ImportError:
            # for POSIX-based systems (with termios & tty support)
            import tty, sys, termios # raises ImportError if unsupported

            def _ttyRead():
                fd = sys.stdin.fileno()
                oldSettings = termios.tcgetattr(fd)

                try:
                    tty.setcbreak(fd)
                    answer = sys.stdin.read(1)
                finally:
                    termios.tcsetattr(fd, termios.TCSADRAIN, oldSettings)

                return answer

            getChar._func=_ttyRead

    return getChar._func()


# Initializing counting sounds. 
mixer.init()
alertClockCorrection = mixer.Sound('Extra.wav')
alertSideveg = mixer.Sound('side.wav')
alertHoyre = mixer.Sound('hoyre.wav')
alertVenstre = mixer.Sound('venstre.wav')
alertExtra = mixer.Sound('Extra.wav')
#alertBuss = mixer.Sound('AtBbuss.wav')


# Creating text file where the traffic registrations are stored.
print("\nSkriv inn navn på filmprosjektet: eks. '18. oktober - kamera b - feltAvInteresse'")
prosjekt = input()
fRegistrations = open('Trafikkregistreringer ' + prosjekt +'.txt', 'w')


# Korreksjon for å beregne total filmtid gitt delfilmtid
print("\nTast inn summert lengde av foregående filmklipp: 'xx:xx:xx' ")
sumTidligereFilm = input()

sFilmstartTime = int(sumTidligereFilm[0:2])
sFilmstartMinutt = int(sumTidligereFilm[3:5])
sFilmstartSekund = int(sumTidligereFilm[6:8])

sumTidligereFilmtid = datetime.timedelta(0, 60 * 60 * sFilmstartTime + 60*sFilmstartMinutt + sFilmstartSekund)


# Updateable field for clockcorrections
print("\nTast inn tidspunkt for klokkesynkronisering: 'xx:xx:xx' = filmstart-tidspunkt for analysen")
analyseFilmstart = input()

aFilmstartTime = int(analyseFilmstart[0:2])
aFilmstartMinutt = int(analyseFilmstart[3:5])
aFilmstartSekund = int(analyseFilmstart[6:8])


# Printing user guidelines
print("\nMarker klokkesynkronisering "+ analyseFilmstart + " med 'k'." + "\n\nRegistrer deretter passeringer:" + "\n'f' for sideveg" + "\n'd' for venstre kjørefelt" + "\n's' for høyre kjørefelt" + "\n\nPress 'q' for å avslutte\n\n")

getChar()

analyseSystemstart = datetime.datetime.now()


print('Klokkesynkronisering: ' + '{:%H:%M:%S}'.format(analyseSystemstart) + ' = ' + analyseFilmstart + '\n')

print(' DELFILMTID : TOTALFILMTID : FLYT')

year = int(str(analyseSystemstart)[0:4])
month = int(str(analyseSystemstart)[5:7])
day = int(str(analyseSystemstart)[8:11])

startAnalysetid = datetime.datetime(year, month, day, aFilmstartTime, aFilmstartMinutt, aFilmstartSekund)


alertClockCorrection.play()


fRegistrations.write('DELFILMTID\tTOTALFILMTID\tKJØREFELT\tKJØRETØY\n')



# Initializing variables 
answer = True
flow = False
validFlowKeys = set('sdf')
validInfoKeys = set('x')
allValidKeys = set('asdfxkz')

writtenPreviousRegistration = True

# Registration loop
while answer != 'q':
    
    answer = getChar() 
    if not any((aVK in allValidKeys) for aVK in answer):
	if answer == 'q':
		if not writtenPreviousRegistration:
			fRegistrations.write(flowString + 'personbil')
		continue
	print('\nUgyldig tast')
	continue

    # Establishing flow
    if answer == 'd':
	flow = 'sideveg '
	alertSideveg.play()	
    
    elif answer == 's':
	flow = 'venstrefelt  '
	alertVenstre.play()

    elif answer == 'f':
	flow = 'høyrefelt '
	alertHoyre.play()

    # Korreksjon    
    elif answer == 'x':
        analysetid = datetime.datetime.now()
	tidsdifferanse = analysetid - analyseSystemstart
	filmtid = startAnalysetid + tidsdifferanse
	print('\nKORREKSJON! Konferer tidsrommet rundt: ' + str(filmtid)[11:str(filmtid).find('.')]),
	infoString = ('\t\t\t\t\t\t\t\tKORREKSJON! KONFERER TIDSROMMET RUNDT: ' + str(filmtid)[11:str(filmtid).find('.')] + '\n')
        alertExtra.play()
    
    # Klokkekontroll
    elif answer == 'k':
	analysetid = datetime.datetime.now()
	tidsdifferanse = analysetid - analyseSystemstart
	filmtid = startAnalysetid + tidsdifferanse
	print('\n\nKLOKKEKONTROLL: \t\t\t\t\t\tANALYSETID = ' + '{:%H:%M:%S}'.format(analysetid) + '  <->  ' + 'FILMTID = ' + str(filmtid)[11:str(filmtid).find('.')])
       
    # Skrive-til-fil-logikk

    if any((vFK in validFlowKeys) for vFK in answer):
	
	if not writtenPreviousRegistration:
		fRegistrations.write(flowString + 'personbil\n')
		
	analysetid = datetime.datetime.now()
	tidsdifferanse = analysetid - analyseSystemstart
	delfilmtid = startAnalysetid + tidsdifferanse
	totalfilmtid = delfilmtid + sumTidligereFilmtid

	print('\n   ' + str(delfilmtid)[11:str(delfilmtid).find('.')] + ' :   ' + str(totalfilmtid)[11:str(totalfilmtid).find('.')] + '   : ' + flow),
	flowString = (str(delfilmtid)[11:str(delfilmtid).find('.')] + '\t' + str(totalfilmtid)[11:str(totalfilmtid).find('.')] + '\t' + flow + '\t')

	writtenPreviousRegistration = False


    elif answer == 'a':
	if not writtenPreviousRegistration:
		if flow == 'friFlyt ':
			print('\t\tDETTE KJØRETØYET VAR NOE ANNET ENN EN VANLIG PERSONBIL'),
		else:
			print('\tDETTE KJØRETØYET VAR NOE ANNET ENN EN VANLIG PERSONBIL'),
		alertExtra.play()
		fRegistrations.write(flowString + 'annet\n')
		writtenPreviousRegistration = True

    elif answer == 'z':
	if not writtenPreviousRegistration:
		if flow == 'friFlyt ':
			print('\t\tAtB-buss'),
		else:
			print('\tAtB-buss'),
		#alertBuss.play()
		fRegistrations.write(flowString + 'AtB-buss\n')
		writtenPreviousRegistration = True


    elif any((vIF in validInfoKeys) for vIF in answer):
	if not writtenPreviousRegistration :
		fRegistrations.write(flowString + 'personbil\n')
		writtenPreviousRegistration = True
	fRegistrations.write(infoString)
	
